/*
 *  Copyright (c) 2020-current NetApp
 *  All rights reserved
 */

// Code generated by lister-gen. DO NOT EDIT.

package v1alpha1

import (
	"k8s.io/apimachinery/pkg/api/errors"
	"k8s.io/apimachinery/pkg/labels"
	"k8s.io/client-go/tools/cache"
	v1alpha1 "quark.netapp.io/volume-controller/pkg/apis/volumecontroller/v1alpha1"
)

// NetAppObjectStoreLister helps list NetAppObjectStores.
// All objects returned here must be treated as read-only.
type NetAppObjectStoreLister interface {
	// List lists all NetAppObjectStores in the indexer.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1alpha1.NetAppObjectStore, err error)
	// NetAppObjectStores returns an object that can list and get NetAppObjectStores.
	NetAppObjectStores(namespace string) NetAppObjectStoreNamespaceLister
	NetAppObjectStoreListerExpansion
}

// netAppObjectStoreLister implements the NetAppObjectStoreLister interface.
type netAppObjectStoreLister struct {
	indexer cache.Indexer
}

// NewNetAppObjectStoreLister returns a new NetAppObjectStoreLister.
func NewNetAppObjectStoreLister(indexer cache.Indexer) NetAppObjectStoreLister {
	return &netAppObjectStoreLister{indexer: indexer}
}

// List lists all NetAppObjectStores in the indexer.
func (s *netAppObjectStoreLister) List(selector labels.Selector) (ret []*v1alpha1.NetAppObjectStore, err error) {
	err = cache.ListAll(s.indexer, selector, func(m interface{}) {
		ret = append(ret, m.(*v1alpha1.NetAppObjectStore))
	})
	return ret, err
}

// NetAppObjectStores returns an object that can list and get NetAppObjectStores.
func (s *netAppObjectStoreLister) NetAppObjectStores(namespace string) NetAppObjectStoreNamespaceLister {
	return netAppObjectStoreNamespaceLister{indexer: s.indexer, namespace: namespace}
}

// NetAppObjectStoreNamespaceLister helps list and get NetAppObjectStores.
// All objects returned here must be treated as read-only.
type NetAppObjectStoreNamespaceLister interface {
	// List lists all NetAppObjectStores in the indexer for a given namespace.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1alpha1.NetAppObjectStore, err error)
	// Get retrieves the NetAppObjectStore from the indexer for a given namespace and name.
	// Objects returned here must be treated as read-only.
	Get(name string) (*v1alpha1.NetAppObjectStore, error)
	NetAppObjectStoreNamespaceListerExpansion
}

// netAppObjectStoreNamespaceLister implements the NetAppObjectStoreNamespaceLister
// interface.
type netAppObjectStoreNamespaceLister struct {
	indexer   cache.Indexer
	namespace string
}

// List lists all NetAppObjectStores in the indexer for a given namespace.
func (s netAppObjectStoreNamespaceLister) List(selector labels.Selector) (ret []*v1alpha1.NetAppObjectStore, err error) {
	err = cache.ListAllByNamespace(s.indexer, s.namespace, selector, func(m interface{}) {
		ret = append(ret, m.(*v1alpha1.NetAppObjectStore))
	})
	return ret, err
}

// Get retrieves the NetAppObjectStore from the indexer for a given namespace and name.
func (s netAppObjectStoreNamespaceLister) Get(name string) (*v1alpha1.NetAppObjectStore, error) {
	obj, exists, err := s.indexer.GetByKey(s.namespace + "/" + name)
	if err != nil {
		return nil, err
	}
	if !exists {
		return nil, errors.NewNotFound(v1alpha1.Resource("netappobjectstore"), name)
	}
	return obj.(*v1alpha1.NetAppObjectStore), nil
}
